%define    debug_package %{nil}

Summary:       The Prometheus monitoring system and time series database
Name:          prometheus
Version:       2.42.0
Release:       3%{?dist}
License:       Apache-2.0
URL:           https://prometheus.io
Source0:       https://github.com/prometheus/prometheus/archive/refs/tags/v%{version}.tar.gz
Source1:       vendor.tar.gz
Source2:       prometheus.service
Source3:       prometheus.yml

Patch3001:     0001-Do-not-force-the-pure-Go-name-resolver.patch
Patch3002:     0002-Default-settings.patch

BuildRequires: fdupes glibc-devel promu golang go-rpm-macros systemd-rpm-macros
Recommends:    firewalld-prometheus-config
Requires(pre): shadow-utils
%{?systemd_requires}

%description
Prometheus's main features are:
 - a multi-dimensional data model (time series identified by metric name and key/value pairs)
 - a flexible query language to leverage this dimensionality
 - no reliance on distributed storage; single server nodes are autonomous
 - time series collection happens via a pull model over HTTP
 - pushing time series is supported via an intermediary gateway
 - targets are discovered via service discovery or static configuration
 - multiple modes of graphing and dashboarding support

%prep
%autosetup -n prometheus-%{version} -p1 -a1

%build
GOPATH=%{_builddir}/go promu build -v

%install
install -D -m0755 %{_builddir}/prometheus-%{version}/prometheus %{buildroot}%{_bindir}/prometheus
install -D -m0755 %{_builddir}/prometheus-%{version}/promtool %{buildroot}%{_bindir}/promtool
install -D -m 0644 %{SOURCE2} %{buildroot}%{_unitdir}/prometheus.service
install -D -m 0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/prometheus/prometheus.yml

install -d -m 0755 %{buildroot}%{_sbindir}
ln -s /usr/sbin/service %{buildroot}%{_sbindir}/rcprometheus

install -m 0755 -d %{buildroot}%{_datarootdir}/prometheus
cp -fr console_libraries/ consoles/ %{buildroot}%{_datarootdir}/prometheus

install -Dd -m 0750 %{buildroot}%{_localstatedir}/lib/prometheus
install -Dd -m 0750 %{buildroot}%{_localstatedir}/lib/prometheus/data
install -Dd -m 0750 %{buildroot}%{_localstatedir}/lib/prometheus/metrics

%pre
getent group prometheus >/dev/null || groupadd -r prometheus
getent passwd prometheus >/dev/null || \
  useradd -r -g prometheus -d %{_sharedstatedir}/prometheus -s /sbin/nologin \
          -c "Prometheus services" prometheus
exit 0

%post
%systemd_post prometheus.service

%preun
%systemd_preun prometheus.service

%postun
%systemd_postun prometheus.service

%files
%defattr(-,root,root,-)
%license LICENSE
%doc README.md
%{_unitdir}/prometheus.service
%{_bindir}/prometheus
%{_bindir}/promtool
%{_sbindir}/rcprometheus
%{_datarootdir}/prometheus
%dir %attr(0700,prometheus,prometheus) %{_sharedstatedir}/prometheus
%dir %attr(0700,prometheus,prometheus) %{_sharedstatedir}/prometheus/data
%dir %attr(0700,prometheus,prometheus) %{_sharedstatedir}/prometheus/metrics
%dir %{_sysconfdir}/prometheus
%config(noreplace) %{_sysconfdir}/prometheus/prometheus.yml

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.42.0-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.42.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Thu Apr 6 2023 Shuo Wang <abushwang@tencent.com> - 2.42.0-1
- initial build

